function [t,u]=beuler(fun,tspan,y0,Nh,varargin)
tt=linspace(tspan(1),tspan(2),Nh+1);
y=y0(:);
u=y.';
global glob_h glob_t glob_y glob_fun;
glob_h=(tspan(2)-tspan(1))/Nh;
glob_y=y; glob_fun=fun;
glob_t=tt(2);

if(~exist ('OCTAVE_VERSION'))
    options=optimset;
    options.Display='off';
    options.TolFun=1.e-06;
    options.MaxFunEvals=10000;
end

for glob_t=tt(2:end)
    if( exist ('OCTAVE_VERSION'))
      w=fsolve('beulerfun',glob_y);
    else
      w=fsolve( @(w) beulerfun(w),glob_y,options);
    end
    u=[u ; w.'];
    glob_y=w;
end
t=tt;
clear glob_h glob_t glob_y glob_fun;
return

function [z]=beulerfun(w)
global glob_h glob_t glob_y glob_fun;
z=w-glob_y-glob_h*feval(glob_fun,glob_t,w);
return


